module key_funcmod(clk, rst, key, led, debug_led);

input clk, rst, key;

`define DEG

`ifndef DEG
output reg [1:0] led;
`else
output [1:0] led;
`endif

output reg debug_led;

//`define DEBUG debug_led <= 1'b1;

parameter T10MS=32'd500_000;

reg F1, F2;

always @(posedge clk or negedge rst)
begin
	if (!rst)
		{F2, F1} <= 2'b11;
	else
		{F2, F1} <= {F1, key};
end

wire isH2L;
wire isL2H;

assign isH2L = (F2 == 1'b1 && F1 == 1'b0);
assign isL2H = (F2 == 1'b0 && F1 == 1'b1);

reg[3:0] i;
reg[31:0] C1;
reg isPress, isRelease;

always @(posedge clk or negedge rst)
begin
	if (!rst)
	begin
		i <= 4'd0;
		{isPress, isRelease} <= 2'b00;
		C1 <= 32'd0;
	end
	else
	begin
		case(i)
			0:
				begin
					if (isH2L)
						i <= i + 1'b1;
						//`DEBUG
				end
			1:
				begin
					if (C1 == T10MS) begin C1 <= 32'd0; i <= i + 1'b1; end
					else begin  C1 <= C1 + 1'b1; end
				end
			2:
				begin
					isPress <= 1'b1;
					i <= i + 1'b1;
				end
			3:
				begin
					isPress <= 1'b0;
					i <= i + 1'b1;
				end
			4:
				begin
					if(isL2H)
						i <= i + 1'b1;
				end
			5:
				begin
					if (C1 == T10MS) begin C1 <= 32'd0; i <= i + 1'b1; end
					else begin  C1 <= C1 + 1'b1; end
				end
			6:
				begin
					isRelease <= 1'b1;
					i <= i + 1'b1;
				end
			7:
				begin
					isRelease <= 1'b0;
					i <= 4'd0;
					//`DEBUG
				end
		endcase
	end
end

reg[1:0] D1;

`define DEG

always @(posedge clk or negedge rst)
begin
	if (!rst)
		`ifdef DEG
		D1 <= 2'b00;
		`else
		led <= 2'b00;
		`endif
	else 
		if (isPress)
			begin
			`ifdef DEG
			D1[0] <= ~D1[0];
			`else
			led[0] <= ~led[0];
			`endif
			//`DEBUG
			end
		else if (isRelease)
			`ifdef DEG
			D1[1] <= ~D1[1];
			`else
			led[1] <= ~led[1];
			`endif
end

`ifdef DEG
assign led = D1;
`endif

endmodule